package org.rcisoft.integration.jieLink.common;

import cn.hutool.core.date.DateUtil;
import cn.hutool.core.lang.UUID;
import cn.hutool.core.util.RandomUtil;
import cn.hutool.crypto.SecureUtil;
import org.apache.commons.lang3.StringUtils;
import org.rcisoft.integration.jieLink.dto.SignDto;


/**
 * 捷顺道闸对接认证工具类
 */
public class SignUtils {

    //全局参数
    public static SignDto signData;



    public static SignDto getSignData(String appId,String key){
        if(StringUtils.isNotBlank(appId)){
            SignDto data = new SignDto();
            data.setAppId(appId);
            data.setRandom(RandomUtil.randomString(16));
            data.setTimestamp(DateUtil.currentSeconds()+"");
            StringBuffer signStr = new StringBuffer();
            //"random" + random + "timestamp" + timestamp + "key" + key
            signStr.append("random");
            signStr.append(data.getRandom());
            signStr.append("timestamp");
            signStr.append(data.getTimestamp());
            signStr.append("key");
            signStr.append(key);
            String encryStr = SecureUtil.md5(signStr.toString()).toUpperCase();
            data.setSign(encryStr);
            return data;
        }else{
            return null;
        }
    }

    public static SignDto getSignData(SignDto data){
        if(data!=null && StringUtils.isNotBlank(data.getAppId())){
            SignDto result = new SignDto();
            result.setKey(data.getKey());
            result.setAppId(data.getAppId());
            result.setRandom(RandomUtil.randomString(16));
            result.setTimestamp(DateUtil.currentSeconds()+"");
            StringBuffer signStr = new StringBuffer();
            //"random" + random + "timestamp" + timestamp + "key" + key
            signStr.append("random");
            signStr.append(result.getRandom());
            signStr.append("timestamp");
            signStr.append(result.getTimestamp());
            signStr.append("key");
            signStr.append(result.getKey());
            String encryStr = SecureUtil.md5(signStr.toString()).toUpperCase();
            result.setSign(encryStr);
            return result;
        }else{
            return null;
        }
    }

    public static void main(String[] args) {
//        SignDto signData = SignUtils.getSignData("1111", "222222222222");
//        System.out.println(signData.getSign());
//        System.out.println(UUID.randomUUID().toString());
        System.out.println(RandomUtil.randomString("ABCDEF0123456789", 8));
    }



}
