package org.rcisoft.integration.jieLink.dto;

import lombok.Data;

import java.util.List;
import java.util.Map;

/**
 * 邀访记录主表
 */
@Data
public class VisitDataInviteDto {

    /**
     * <pre>
     *邀访记录 ID
     *  36 位 Guid
     *  必填
     * </pre>
     */
    private String	itemId;

    /**
     * <pre>
     *受访人 ID
     * 捷顺系统的ID
     * </pre>
     */
    private String	personId;

    /**
     * <pre>
     *邀访时间表达式
     * 由 JSON 格式组成：
     * sd:开始时间
     * ed:结束时间
     * st:周期开始时间， 配合周期一起用
     * et:周期结束时间， 配合周期一起用
     * w： 周期， 从周一到周日共 7位， 为 0 表示无效， 为 1 表示有效
     * </pre>
     */
    private String	timeDesc;

    /**
     * <pre>
     *访客类型
     * 1: 外卖
     * 2: 家政
     * 3: 普通访客
     * 4: VIP 访客
     * 5: 特殊访客
     * </pre>
     */
    private String	visitorType;

    /**
     * <pre>
     * 来访事由
     * </pre>
     */
    private String content;

    /**
     * <pre>
     *     设备区域列表
     * </pre>
     */
    private List<Map<String,String>> deviceApList;

}
