package org.rcisoft.integration.jieLink.service;

import org.rcisoft.integration.jieLink.dto.JieLinkDoorRecordDto;
import org.rcisoft.integration.jieLink.dto.JieLinkResultDto;
import org.rcisoft.integration.jieLink.dto.SignDto;
import org.rcisoft.sys.sysuser.entity.SysUser;
import org.rcisoft.sys.visit.entity.VisitInfoMation;
import org.springframework.stereotype.Service;

/**
 * 捷顺道闸对接服务接口
 */
@Service
public interface IJieLinkService {

    /**
     * 获取签名所需相关参数
     * @return
     */
    public SignDto getAppKeyInfo();


    /**
     * 推送新增用户对象到捷顺服务中
     * @param userData
     * @return
     */
    public boolean pushAddUserData(SysUser userData);


    /**
     * 推送更新的用户信息到接口服务中
     * @param userData
     * @return
     */
    public boolean pushModifyUserData(SysUser userData);

    /**
     * 推送更新的用户信息到接口服务中
     * @param userData
     * @return
     */
    public boolean pushDelUserData(SysUser userData);


    /**
     * 推送方可邀请记录到接口服务中
     * @param visitInfoMation
     * @return
     */
    public boolean pushVisitorData(VisitInfoMation visitInfoMation);

    /**
     * 撤销邀访记录
     * @param visitUserId 邀访人Id
     * @param visitInfoId 邀请记录ID
     * @return
     */
    public boolean cancelVisitorData(String visitUserId,String visitInfoId);


    /***
     * 拉取访客所需的二维码信息
     * @return
     */
    public String pullVisitUserQrCode(String visitUserId);

    /**
     * 保存门禁访问记录
     * @param recordDto
     * @return
     */
    public JieLinkResultDto saveDoorRecordInfo(JieLinkDoorRecordDto recordDto);

    public void syncDeviceInfo();

    public void getDeptList();

}
